//Play Gwent Whenever by pMarK

class PlayGwentWhenever{
	
	private var gwintManager : CR4GwintManager;
	
	public function Init()
	{
		SetupInputs();
	}
	
	private function SetupInputs()
	{
		theInput.RegisterListener( this, 'OnCommPlayGwent', 'PlayGwentNow' );
	}
	
	event OnCommPlayGwent( action:SInputAction )
	{
		if( IsPressed( action ) )
		{
			SetUpGame();
		}
	}
	
	private function GetSelectedEnemy() : name
	{
		var selectedFaction : Int32;
		var selectedDifficulty : Int32;
		var deck : name;
		
		selectedFaction = StringToInt( theGame.GetInGameConfigWrapper().GetVarValue( 'playGwentWhenever', 'pgwOpponent' ) );
		selectedDifficulty = StringToInt( theGame.GetInGameConfigWrapper().GetVarValue( 'playGwentWhenever', 'pgwDifficulty' ) );
		
		switch(selectedFaction)
		{
			case 0:
				if(selectedDifficulty == 0)
					deck = 'NKEasy';
				else if(selectedDifficulty == 1)
					deck = 'NKNormal';
				else if(selectedDifficulty == 2)
					deck = 'NKHard';
			break;
			
			case 1:
				if(selectedDifficulty == 0)
					deck = 'NilfEasy';
				else if(selectedDifficulty == 1)
					deck = 'NilfNormal';
				else if(selectedDifficulty == 2)
					deck = 'NilfHard';
			break;
			
			case 2:
				if(selectedDifficulty == 0)
					deck = 'ScoiaEasy';
				else if(selectedDifficulty == 1)
					deck = 'ScoiaNormal';
				else if(selectedDifficulty == 2)
					deck = 'ScoiaHard';
			break;
			
			case 3:
				if(selectedDifficulty == 0)
					deck = 'NMLEasy';
				else if(selectedDifficulty == 1)
					deck = 'NMLNormal';
				else if(selectedDifficulty == 2)
					deck = 'NMLHard';
			break;
		}
		
		return deck;
	}
	
	private function SetUpGame() : void
	{
		var isModOn : bool;
		
		isModOn = theGame.GetInGameConfigWrapper().GetVarValue( 'playGwentWhenever', 'pgwSwitch' );
		
		if(isModOn)
		{
			gwintManager = theGame.GetGwintManager();
			gwintManager.setDoubleAIEnabled(false);
			gwintManager.SetEnemyDeckByName(GetSelectedEnemy());
			gwintManager.testMatch = true;
			gwintManager.gameRequested = true;
			theGame.RequestMenu( 'DeckBuilder' );
		}
		else
			thePlayer.DisplayHudMessage("The Mod is OFF");
	}
}